# Hubess Basic Template

Para utilizar esse template é necessário executar o comando:

`$ npx react-native init AwesomeBasic --template hubess-basic`


## Automação do Lint com Husky

Para automatizar lint ao realizar "commits" adicione esse trecho de código no arquivo `package.json`

```
"husky": {
  "hooks": {
    "pre-commit": "lint-staged"
    }
},
"lint-staged": {
  "src/**/*.js": ["yarn lint --fix"]
}
```

## Scripts úteis (opcional)

Caso opte por utilizar scripts já criados para esse projeto, substitua o atributo "scripts" do `package.json` por este:

```
...
"scripts": {
  "android": "cross-env ENVFILE=.env && react-native run-android",
  "android-prod": "cross-env ENVFILE=.env.prod && react-native run-android",
  "android-build": "export ENVFILE=.env.prod && cd ./android && ./gradlew assembleRelease && cd ..",
  "android-release": "export ENVFILE=.env.prod && cd ./android && ./gradlew bundleRelease && cd ..",
  "ios": "react-native run-ios",
  "start": "react-native start",
  "test": "jest",
  "lint": "eslint ./src",
  "generate": "plop"
},
...
```

### Scripts

Para utilizar o gerador de códigos execute `$ yarn generate <component | page | 
context> <options>`

Componentes: `$ yarn generate component Button /components/ui/`

Contextos: `$ yarn generate context User y user`

Páginas: `$ yarn generate page Home /home`

Em caso de dúvidas execute o comando `$ yarn generate context` que irá te 
enviar para um prompt onde basta responder algumas perguntas para gerar seu 
contexto.

## Primeiros passos

Antes de rodar o projeto a primeira vez, lembre-se de criar um arquivo `.env` e 
um `.env.prod` contendo as apis utilizadas e/ou chaves secretas (não recomendado
), para criá-las basta seguir o arquivo `.env.example`.

## Passos adicionais

### Android

Para o `.env` funcionar adicione no final do arquivo `android/app/build.gradle`
a seguinte linha:

```
apply from: project(':react-native-config').projectDir.getPath() + "/dotenv.gradle"
```